package tech.loedige;

import util.Dump;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;

public class Main {

    public static void main(String[] args) throws NoSuchAlgorithmException, InterruptedException {
       //SHA1_Aufgabe();
       //SHA256_Aufgabe();
        //iterationCountAufgabe();
        birthdayParadox(0.5d);
        birthdayParadox(0.9d);
        birthdayParadox(0.99d);
    }

    private static void birthdayParadox(double propability){
       double counter=0;
       double current=1;
       while(1-current<propability){
           counter++;
           current*=1-(counter/365);
       }
       System.out.println((counter+1) + ": " + (1-current));
    }

    private static void iterationCountAufgabe() throws NoSuchAlgorithmException {
        int c = 0;
        byte[] alice = Dump.hexString2byteArray("31323334353622445CBCBDFD10E00EA6");
        boolean finished = false;
        var md = MessageDigest.getInstance("SHA-256");

        while(!finished){
            c++;
            alice = md.digest(alice);
            finished = testCurrent(alice,Dump.hexString2byteArray("DADCC5"),Dump.hexString2byteArray("786532"));
            System.out.println(c);
        }
    }

    private static boolean testCurrent(byte[] current, byte[] g_beginning, byte[] g_ending){
        for(int i =0; i<g_beginning.length; i++){
            if(current[i]!=g_beginning[i])
                return false;
        }
        for(int i = 0; i<g_ending.length; i++){
            if(current[current.length - 1 -i]!=g_ending[g_ending.length - 1 - i])
                return false;
        }
        return true;
    }

    private static void SHA256_Aufgabe() throws NoSuchAlgorithmException, InterruptedException {
        var md = MessageDigest.getInstance("SHA-256");
        System.out.println(Dump.dumpString(md.digest(("123456").getBytes())));
        //md = MessageDigest.getInstance("SHA-1");
        System.out.println(Dump.dumpString(md.digest(("rj5gt7hog4m9gxtinokx").getBytes())));
        System.out.println(Dump.dumpString(md.digest(("admin").getBytes())));
        byte[] input = Dump.hexString2byteArray("ADDB0F5E7826C857D7376D1BD9BC33C0C544790A2EAC96144A8AF22B1298C940");
        System.out.println(bruteForcePassword(input));
    }

    private static String bruteForcePassword(byte[] input) throws NoSuchAlgorithmException, InterruptedException {
        System.out.println("Warning! This might take a while");
        var md = MessageDigest.getInstance("SHA-256");
        for(int i1= 0 ; i1<26;i1++){
            for(int i2= 0 ; i2<26;i2++) {
                System.out.println((((i1*26+i2)*100)/676) + "% of all possibilities tried");
                for (int i3 = 0; i3 < 26; i3++) {
                    for (int i4 = 0; i4 < 26; i4++) {
                        for (int i5 = 0; i5 < 26; i5++) {
                            for (int i6 = 0; i6 < 26; i6++) {
                                byte[] pos = {'a','a','a','a','a','a'};
                                pos[0] += i1;
                                pos[1] += i2;
                                pos[2] += i3;
                                pos[3] += i4;
                                pos[4] += i5;
                                pos[5] += i6;
                                byte[] output = md.digest(pos);
                                if (Arrays.equals(output,input)) {
                                    return new String(pos);
                                }
                            }
                        }
                    }
                }
            }
        }
        return "nothing found";
    }

    private static void SHA1_Aufgabe() throws NoSuchAlgorithmException {
        byte[] data1 = util.Dump.hexString2byteArray(""
                + "D131DD02C5E6EEC4693D9A0698AFF95C2FCAB58712467EAB"
                + "4004583EB8FB7F8955AD340609F4B30283E488832571415A"
                + "085125E8F7CDC99FD91DBDF280373C5BD8823E3156348F5B"
                + "AE6DACD436C919C6DD53E2B487DA03FD02396306D248CDA0"
                + "E99F33420F577EE8CE54B67080A80D1EC69821BCB6A88393"
                + "96F9652B6FF72A70");

        byte[] data2 = util.Dump.hexString2byteArray(""
                + "D131DD02C5E6EEC4693D9A0698AFF95C2FCAB50712467EAB"
                + "4004583EB8FB7F8955AD340609F4B30283E4888325F1415A"
                + "085125E8F7CDC99FD91DBD7280373C5BD8823E3156348F5B"
                + "AE6DACD436C919C6DD53E23487DA03FD02396306D248CDA0"
                + "E99F33420F577EE8CE54B67080280D1EC69821BCB6A88393"
                + "96F965AB6FF72A70");
        var messageDigest = MessageDigest.getInstance("MD5");
        System.out.println(Dump.dumpString(messageDigest.digest(data1)));
        System.out.println(Dump.dumpString(messageDigest.digest(data2)));
        for(int i = 0 ; i < data1.length; i++){
            System.out.print((data1[i]^data2[i]) + " ");
        }
    }
}
